#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;

#endregion



#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		
		private ChartSpots.MACDImproved[] cacheMACDImproved;

		
		public ChartSpots.MACDImproved MACDImproved(int fast, int slow, int smooth)
		{
			return MACDImproved(Input, fast, slow, smooth);
		}


		
		public ChartSpots.MACDImproved MACDImproved(ISeries<double> input, int fast, int slow, int smooth)
		{
			if (cacheMACDImproved != null)
				for (int idx = 0; idx < cacheMACDImproved.Length; idx++)
					if (cacheMACDImproved[idx].Fast == fast && cacheMACDImproved[idx].Slow == slow && cacheMACDImproved[idx].Smooth == smooth && cacheMACDImproved[idx].EqualsInput(input))
						return cacheMACDImproved[idx];
			return CacheIndicator<ChartSpots.MACDImproved>(new ChartSpots.MACDImproved(){ Fast = fast, Slow = slow, Smooth = smooth }, input, ref cacheMACDImproved);
		}

	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		
		public Indicators.ChartSpots.MACDImproved MACDImproved(int fast, int slow, int smooth)
		{
			return indicator.MACDImproved(Input, fast, slow, smooth);
		}


		
		public Indicators.ChartSpots.MACDImproved MACDImproved(ISeries<double> input , int fast, int slow, int smooth)
		{
			return indicator.MACDImproved(input, fast, slow, smooth);
		}
	
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		
		public Indicators.ChartSpots.MACDImproved MACDImproved(int fast, int slow, int smooth)
		{
			return indicator.MACDImproved(Input, fast, slow, smooth);
		}


		
		public Indicators.ChartSpots.MACDImproved MACDImproved(ISeries<double> input , int fast, int slow, int smooth)
		{
			return indicator.MACDImproved(input, fast, slow, smooth);
		}

	}
}

#endregion
